/**
 *
 * Copyright (C) 2013, 2014 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/

#include "Plane.h"


Plane::Plane(){}

Plane::Plane(const gk::Vector& v1, const gk::Vector& v2, const gk::Vector& v3):o(v2){
 
   Plane::normal = (v3-v2)*(v1-v2);

  if(normal.Length()>0)
    normal = Normalize(normal);

  Plane::d = -1.0 * Dot(normal,o);

}

Plane::Plane(const Plane& p):normal(p.normal),o(p.o),d(p.d){}

Plane::~Plane(){}

void Plane::setCoefficients(float a, float b, float c, float d) {

  // set the normal vector
  normal = gk::Vector(a,b,c);
  //compute the lenght of the vector
  float l = normal.Length();
  // normalize the vector
  normal= gk::Vector(a/l,b/l,c/l);
  // and divide d by th length as well
  this->d = d/l;
}

std::ostream & operator <<(std::ostream & os, const Plane& p){
  os<<"Plane ("<<","<<p.d<<")"<<std::endl;
  p.normal.print();
  return os;
}
