/**
 *
 * Copyright (C) 2013, 2014 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/

#ifndef PLANE_H
#define PLANE_H


#include "Geometry.h"


class Plane{

 private:

 protected: 
  gk::Vector normal;
  gk::Vector o;
  double d;

 public:
  Plane();
  Plane(const gk::Vector& v1, const gk::Vector& v2, const gk::Vector& v3);  
  Plane(const Plane&);
  ~Plane();

 inline double distance(const gk::Vector& p)const{
   return d + Dot(normal , p);
 }

 void setCoefficients(float a, float b, float c, float d);

 friend std::ostream & operator <<(std::ostream &, const Plane&);

};


#endif //PLANE_H
